#!/bin/sh
## 'slink' script
## Since		11/02/2004 (WmT, 'slink' for mybb)
## Last modified	22/07/2004 (WmT, 'slink' for freglx/stubs)

do_remove()
{
	if [ -z "$1" ] ; then
		echo "$0: No SRCDIR"
		exit 1
	else
		SRCDIR=$1
		shift
	fi

	( find ${SRCDIR} -type f ; find ${SRCDIR} -type l ) | while read SOURCE ; do
		TARGET=./`basename ${SOURCE}`
		[ -L ${TARGET} ] && rm ${TARGET}
	done
}

do_add()
{
	if [ -z "$1" ] ; then
		echo
		echo "*** ...this script links chosen sources to current directory ***"
		echo
		echo "$0: No SRCDIR"
		exit 1
	else
		SRCDIR=$1
		shift
	fi

	( find ${SRCDIR} -type f ; find ${SRCDIR} -type l ) | while read SOURCE ; do
		TARGET=./`basename ${SOURCE}`
		ln -sf ${SOURCE} ${TARGET}
	done
}

ACTION=$1
[ "${ACTION}" ] && shift
case ${ACTION} in
add)	## add links from given directory [to current directory]
	do_add $* || exit 1
	echo "$0: INSTALL phase OK"
	;;
remove)	## remove added links [from current directory]
	do_remove $* || exit 1
	echo "$0: UNINSTALL phase OK"
	;;
*)
	if [ -n "${ACTION}" -a "${ACTION}" != 'help' ] ; then
		echo "$0: Unrecognised COMMAND '${ACTION}'" 1>&2
	fi
	echo "$0: Usage:" 1>&2
	grep "^[0-9a-z-]*)" $0 | sed "s/^/	/" 1>&2
	exit 1
	;;
esac
